// @ts-ignore
importScripts("./ComPDFkit.js")

import MessageHandler from "./messageHandler"

async function sleep(delay: number) {
  await new Promise((resolve) => setTimeout(resolve, delay))
}

class ComPDFKitWorker {
  static messageHandler: MessageHandler
  static setup(self: typeof globalThis) {
    const messageHandler = new MessageHandler('worker', self)
    this.messageHandler = messageHandler

    
  }
}

async function setUp(): Promise<void> {
  // @ts-ignore
  while (!runtimeInitialized) {
    await sleep(100)
  }
  return new Promise((resolve, reject) => {
    resolve()
  })
}

setUp().then(() => {
  function ready (gloabal: typeof globalThis) {
    gloabal.onmessage = function (e: MessageEvent) {
      const action = e.data.action
      if (action === 'init') {
        ComPDFKitWorker.setup(gloabal)
      }
    }
  }

  ready(typeof window !== 'undefined' ? window : self)
})
